' INIL.bas generates  L_INI.DAT  for  LIFE..EXE     McCopies & D.Stribute 2001
' V2.0  loop in and start life..exe from INIL.BAS (instead from L.BAT)

'  --- initialize parameters: ---

x0 = 41: y0 = 12          ' center  x0/y0 in screen mode 80*25
xxmin = 4: xxmax = 12     ' rectangle:   xx*yy
yymin = 2: yymax = 6
nmin = 5: nmax = 70       ' n = number of stones     [1..250]


count& = 0
RANDOMIZE TIMER

lbl1:   ' ------ generate (next) randomized L_INI.DAT : ------

n = nmin + INT((nmax - nmin) * RND) ' n = number of stones     [1..250]
xx = xxmin + INT((xxmax - xxmin) * RND)
yy = yymin + INT((yymax - yymin) * RND)

' Verzgerungsfaktor:  ***  delay/generation in 1/18.2 secs
       
delay = INT(RND * 180)         ' =rand(0..180)
IF delay > 36 THEN delay = 0   ' 80% delay=0
IF delay > 18 THEN delay = 1   ' 10% delay=1 == 1/18 secs per generation
                               ' 10% delay=rand(0..18) ticks

' delay = 1

OPEN "L_INI.DAT" FOR OUTPUT AS #1
PRINT #1, CHR$(delay);       ' byte1 = delay
PRINT #1, CHR$(n);           ' byte2 = n = # of x/y
FOR i = 1 TO n                       ' make+write n x/y pairs
x = x0 + INT(RND * xx - xx / 2)      ' rectangular distribution
y = y0 + INT(RND * yy - yy / 2)
PRINT #1, CHR$(x); CHR$(y);
NEXT i
PRINT #1, "X--EOF--X";    ' add eof mark  9 bytes
CLOSE #1
count& = count& + 1

' ----- run LIFE..EXE  using LEXE.BAT (to check ERRORLEVEL on exit) -----

SHELL "LEXE.BAT"    ' run LIFE..EXE,     and
' if it seems interesting, save L_INI.DAT (type l_ini.dat >> saved.dat)

delay = .1

endTime = TIMER + delay       '    (will hang at midnight)
WHILE TIMER < endTime         ' -- wait for delay secs
IF INKEY$ = CHR$(27) GOTO lblex       ' -- checking for <ESC>
WEND

IF INKEY$ = CHR$(27) GOTO lblex       ' -- check for <ESC> even if delay=0
GOTO lbl1      ' -- loop

lblex:
PRINT count&; " runs. ": PRINT
PRINT " ciao !! ": PRINT
SYSTEM

SUB RANDO            ' "randomized timer" optimized

' calc seed for random number generator depending on clock-ticks
' timer = seconds since midnight: 0...86400  inc. every 18.2 secs
x& = INT(TIMER * 19) MOD 65536 - 32768    ' x& = -32768..32767
RANDOMIZE x&
D$ = DATE$   ' mm-dd-yyyy
             ' 1234567890
k0 = ASC("0")
km = ASC(MID$(D$, 1, 1)) - k0
km = km * 10 + ASC(MID$(D$, 2, 1)) - k0
kd = ASC(MID$(D$, 4, 1)) - k0
kd = kd * 10 + ASC(MID$(D$, 5, 1)) - k0
kd = 32 * (km - 1) + kd

kd = kd MOD 41           ' random choice ! modify randomly

' modify random number sequence by skipping some numbers
' depending on day-of-year

FOR i = 1 TO kd
dummy = RND
NEXT i

END SUB

